Index: pjproject/trunk/pjnath/src/pjturn-client/client_main.c
===================================================================
--- pjproject/trunk/pjnath/src/pjturn-client/client_main.c	(revision 1912)
+++ pjproject/trunk/pjnath/src/pjturn-client/client_main.c	(revision 1913)
@@ -49,5 +49,5 @@
     pj_bool_t		 quit;
 
-    pj_turn_udp		*udp_rel;
+    pj_turn_sock	*relay;
     pj_sockaddr		 relay_addr;
 
@@ -57,20 +57,21 @@
 static struct options
 {
-    char    *srv_addr;
-    char    *srv_port;
-    char    *realm;
-    char    *user_name;
-    char    *password;
-    pj_bool_t use_fingerprint;
+    pj_bool_t	 use_tcp;
+    char	*srv_addr;
+    char	*srv_port;
+    char	*realm;
+    char	*user_name;
+    char	*password;
+    pj_bool_t	 use_fingerprint;
 } o;
 
 
 static int worker_thread(void *unused);
-static void turn_on_rx_data(pj_turn_udp *udp_rel,
+static void turn_on_rx_data(pj_turn_sock *relay,
 			    const pj_uint8_t *pkt,
 			    unsigned pkt_len,
 			    const pj_sockaddr_t *peer_addr,
 			    unsigned addr_len);
-static void turn_on_state(pj_turn_udp *udp_rel, pj_turn_state_t old_state,
+static void turn_on_state(pj_turn_sock *relay, pj_turn_state_t old_state,
 			  pj_turn_state_t new_state);
 
@@ -156,7 +157,7 @@
 	g.thread = NULL;
     }
-    if (g.udp_rel) {
-	pj_turn_udp_destroy(g.udp_rel);
-	g.udp_rel = NULL;
+    if (g.relay) {
+	pj_turn_sock_destroy(g.relay);
+	g.relay = NULL;
     }
     for (i=0; i<PJ_ARRAY_SIZE(g.peer); ++i) {
@@ -243,10 +244,10 @@
 static pj_status_t create_relay(void)
 {
-    pj_turn_udp_cb rel_cb;
+    pj_turn_sock_cb rel_cb;
     pj_stun_auth_cred cred;
     pj_str_t srv;
     pj_status_t status;
 
-    if (g.udp_rel) {
+    if (g.relay) {
 	PJ_LOG(1,(THIS_FILE, "Relay already created"));
 	return -1;
@@ -256,6 +257,8 @@
     rel_cb.on_rx_data = &turn_on_rx_data;
     rel_cb.on_state = &turn_on_state;
-    CHECK( pj_turn_udp_create(&g.stun_config, pj_AF_INET(), &rel_cb, 0,
-			      NULL, &g.udp_rel) );
+    CHECK( pj_turn_sock_create(&g.stun_config, pj_AF_INET(), 
+			       (o.use_tcp? PJ_TURN_TP_TCP : PJ_TURN_TP_UDP),
+			       &rel_cb, 0,
+			       NULL, &g.relay) );
 
     if (o.user_name) {
@@ -272,5 +275,5 @@
 
     srv = pj_str(o.srv_addr);
-    CHECK( pj_turn_udp_init(g.udp_rel,				 /* the relay */
+    CHECK( pj_turn_sock_init(g.relay,				 /* the relay */
 			    &srv,				 /* srv addr */
 			    (o.srv_port?atoi(o.srv_port):PJ_STUN_PORT),/* def port */
@@ -285,11 +288,11 @@
 static void destroy_relay(void)
 {
-    if (g.udp_rel) {
-	pj_turn_udp_destroy(g.udp_rel);
-    }
-}
-
-
-static void turn_on_rx_data(pj_turn_udp *udp_rel,
+    if (g.relay) {
+	pj_turn_sock_destroy(g.relay);
+    }
+}
+
+
+static void turn_on_rx_data(pj_turn_sock *relay,
 			    const pj_uint8_t *pkt,
 			    unsigned pkt_len,
@@ -306,5 +309,5 @@
 
 
-static void turn_on_state(pj_turn_udp *udp_rel, pj_turn_state_t old_state,
+static void turn_on_state(pj_turn_sock *relay, pj_turn_state_t old_state,
 			  pj_turn_state_t new_state)
 {
@@ -314,9 +317,9 @@
     if (new_state == PJ_TURN_STATE_READY) {
 	pj_turn_session_info info;
-	pj_turn_udp_get_info(udp_rel, &info);
+	pj_turn_sock_get_info(relay, &info);
 	pj_memcpy(&g.relay_addr, &info.relay_addr, sizeof(pj_sockaddr));
-    } else if (new_state > PJ_TURN_STATE_READY && g.udp_rel) {
+    } else if (new_state > PJ_TURN_STATE_READY && g.relay) {
 	PJ_LOG(3,(THIS_FILE, "Relay shutting down.."));
-	g.udp_rel = NULL;
+	g.relay = NULL;
     }
 }
@@ -327,6 +330,6 @@
     char client_state[20], relay_addr[80], peer0_addr[80], peer1_addr[80];
 
-    if (g.udp_rel) {
-	pj_turn_udp_get_info(g.udp_rel, &info);
+    if (g.relay) {
+	pj_turn_sock_get_info(g.relay, &info);
 	strcpy(client_state, pj_turn_state_name(info.state));
 	if (info.state >= PJ_TURN_STATE_READY)
@@ -358,5 +361,5 @@
 	  peer1_addr);
     puts("+-----------------------------------+                                |");
-    puts("| q  Quit        d  Dump            | 1  Send data to relay adderss  |");
+    puts("| q  Quit                  d  Dump  | 1  Send data to relay adderss  |");
     puts("+-----------------------------------+--------------------------------+");
     printf(">>> ");
@@ -385,5 +388,5 @@
 	    break;
 	case 's':
-	    if (g.udp_rel == NULL) {
+	    if (g.relay == NULL) {
 		puts("Error: no relay");
 		continue;
@@ -395,5 +398,5 @@
 
 	    strcpy(input, "Hello from client");
-	    status = pj_turn_udp_sendto(g.udp_rel, (const pj_uint8_t*)input, 
+	    status = pj_turn_sock_sendto(g.relay, (const pj_uint8_t*)input, 
 					strlen(input)+1, 
 					&peer->addr, 
@@ -403,5 +406,5 @@
 	    break;
 	case 'b':
-	    if (g.udp_rel == NULL) {
+	    if (g.relay == NULL) {
 		puts("Error: no relay");
 		continue;
@@ -412,11 +415,14 @@
 		peer = &g.peer[1];
 
-	    status = pj_turn_udp_bind_channel(g.udp_rel, &peer->addr,
+	    status = pj_turn_sock_bind_channel(g.relay, &peer->addr,
 					      pj_sockaddr_get_len(&peer->addr));
 	    if (status != PJ_SUCCESS)
 		my_perror("turn_udp_bind_channel() failed", status);
 	    break;
+	case 'd':
+	    pj_pool_factory_dump(&g.cp.factory, PJ_TRUE);
+	    break;
 	case 'x':
-	    if (g.udp_rel == NULL) {
+	    if (g.relay == NULL) {
 		puts("Error: no relay");
 		continue;
@@ -426,5 +432,5 @@
 	case '0':
 	case '1':
-	    if (g.udp_rel == NULL) {
+	    if (g.relay == NULL) {
 		puts("No relay");
 		break;
@@ -451,8 +457,9 @@
     puts("");
     puts("and OPTIONS:");
-    puts(" --realm, -r       Set realm of the credential");
-    puts(" --username, -u    Set username of the credential");
-    puts(" --password, -p    Set password of the credential");
-    puts(" --fingerprint, -F Use fingerprint for outgoing requests");
+    puts(" --tcp, -T             Use TCP to connect to TURN server");
+    puts(" --realm, -r REALM     Set realm of the credential to REALM");
+    puts(" --username, -u UID    Set username of the credential to UID");
+    puts(" --password, -p PASSWD Set password of the credential to PASSWD");
+    puts(" --fingerprint, -F     Use fingerprint for outgoing requests");
     puts(" --help, -h");
 }
@@ -465,5 +472,5 @@
 	{ "password",	1, 0, 'p'},
 	{ "fingerprint",0, 0, 'F'},
-	{ "data",	1, 0, 'D'},
+	{ "tcp",        0, 0, 'T'},
 	{ "help",	0, 0, 'h'}
     };
@@ -472,5 +479,5 @@
     pj_status_t status;
 
-    while((c=pj_getopt_long(argc,argv, "r:u:p:N:hF", long_options, &opt_id))!=-1) {
+    while((c=pj_getopt_long(argc,argv, "r:u:p:N:hFT", long_options, &opt_id))!=-1) {
 	switch (c) {
 	case 'r':
@@ -488,4 +495,7 @@
 	case 'F':
 	    o.use_fingerprint = PJ_TRUE;
+	    break;
+	case 'T':
+	    o.use_tcp = PJ_TRUE;
 	    break;
 
Index: pjproject/trunk/pjnath/src/pjturn-srv/allocation.c
===================================================================
--- pjproject/trunk/pjnath/src/pjturn-srv/allocation.c	(revision 1912)
+++ pjproject/trunk/pjnath/src/pjturn-srv/allocation.c	(revision 1913)
@@ -66,4 +66,5 @@
                             pj_ssize_t bytes_read);
 static pj_status_t stun_on_send_msg(pj_stun_session *sess,
+				    void *token,
 				    const void *pkt,
 				    pj_size_t pkt_size,
@@ -74,4 +75,5 @@
 				      unsigned pkt_len,
 				      const pj_stun_rx_data *rdata,
+				      void *token,
 				      const pj_sockaddr_t *src_addr,
 				      unsigned src_addr_len);
@@ -80,4 +82,5 @@
 					 unsigned pkt_len,
 					 const pj_stun_msg *msg,
+					 void *token,
 					 const pj_sockaddr_t *src_addr,
 					 unsigned src_addr_len);
@@ -124,5 +127,5 @@
 	pj_stun_session_respond(sess, rdata, 
 				PJ_STUN_SC_ALLOCATION_QUOTA_REACHED,
-			        "Invalid bandwidth", PJ_TRUE,
+			        "Invalid bandwidth", NULL, PJ_TRUE,
 				src_addr, src_addr_len);
 	return PJ_STATUS_FROM_STUN_CODE(PJ_STUN_SC_ALLOCATION_QUOTA_REACHED);
@@ -135,5 +138,5 @@
 	pj_stun_session_respond(sess, rdata, PJ_STUN_SC_BAD_REQUEST,
 			        "Missing REQUESTED-TRANSPORT attribute", 
-				PJ_TRUE, src_addr, src_addr_len);
+				NULL, PJ_TRUE, src_addr, src_addr_len);
 	return PJ_STATUS_FROM_STUN_CODE(PJ_STUN_SC_BAD_REQUEST);
     }
@@ -144,5 +147,5 @@
     if (cfg->tp_type != PJ_TURN_TP_UDP) {
 	pj_stun_session_respond(sess, rdata, PJ_STUN_SC_UNSUPP_TRANSPORT_PROTO,
-				NULL, PJ_TRUE, src_addr, src_addr_len);
+				NULL, NULL, PJ_TRUE, src_addr, src_addr_len);
 	return PJ_STATUS_FROM_STUN_CODE(PJ_STUN_SC_UNSUPP_TRANSPORT_PROTO);
     }
@@ -156,6 +159,6 @@
 	pj_stun_session_respond(sess, rdata, 
 				PJ_STUN_SC_BAD_REQUEST,
-				"RESERVATION-TOKEN is not supported", PJ_TRUE, 
-				src_addr, src_addr_len);
+				"RESERVATION-TOKEN is not supported", NULL, 
+				PJ_TRUE, src_addr, src_addr_len);
 	return PJ_STATUS_FROM_STUN_CODE(PJ_STUN_SC_BAD_REQUEST);
     }
@@ -168,6 +171,6 @@
 	pj_stun_session_respond(sess, rdata, 
 				PJ_STUN_SC_BAD_REQUEST,
-				"REQUESTED-PROPS is not supported", PJ_TRUE, 
-				src_addr, src_addr_len);
+				"REQUESTED-PROPS is not supported", 
+				NULL, PJ_TRUE, src_addr, src_addr_len);
 	return PJ_STATUS_FROM_STUN_CODE(PJ_STUN_SC_BAD_REQUEST);
     }
@@ -180,6 +183,6 @@
 	if (cfg->lifetime < MIN_LIFETIME) {
 	    pj_stun_session_respond(sess, rdata, PJ_STUN_SC_BAD_REQUEST,
-				    "LIFETIME too short", PJ_TRUE, 
-				    src_addr, src_addr_len);
+				    "LIFETIME too short", NULL, 
+				    PJ_TRUE, src_addr, src_addr_len);
 	    return PJ_STATUS_FROM_STUN_CODE(PJ_STUN_SC_BAD_REQUEST);
 	}
@@ -197,4 +200,5 @@
 static pj_status_t send_allocate_response(pj_turn_allocation *alloc,
 					  pj_stun_session *srv_sess,
+					  pj_turn_transport *transport,
 					  const pj_stun_rx_data *rdata)
 {
@@ -233,6 +237,6 @@
     
     /* Send the response */
-    return pj_stun_session_send_msg(srv_sess, PJ_TRUE,
-				    &alloc->hkey.clt_addr, 
+    return pj_stun_session_send_msg(srv_sess, transport, PJ_TRUE,
+				    PJ_FALSE, &alloc->hkey.clt_addr, 
 				    pj_sockaddr_get_len(&alloc->hkey.clt_addr),
 				    tdata);
@@ -284,5 +288,5 @@
  * Create new allocation.
  */
-PJ_DEF(pj_status_t) pj_turn_allocation_create(pj_turn_listener *listener,
+PJ_DEF(pj_status_t) pj_turn_allocation_create(pj_turn_transport *transport,
 					      const pj_sockaddr_t *src_addr,
 					      unsigned src_addr_len,
@@ -291,5 +295,5 @@
 					      pj_turn_allocation **p_alloc)
 {
-    pj_turn_srv *srv = listener->server;
+    pj_turn_srv *srv = transport->listener->server;
     const pj_stun_msg *msg = rdata->msg;
     pj_pool_t *pool;
@@ -311,11 +315,14 @@
     alloc->pool = pool;
     alloc->obj_name = pool->obj_name;
-    alloc->listener = listener;
-    alloc->clt_sock = PJ_INVALID_SOCKET;
     alloc->relay.tp.sock = PJ_INVALID_SOCKET;
+    alloc->server = transport->listener->server;
 
     alloc->bandwidth = req.bandwidth;
 
-    alloc->hkey.tp_type = listener->tp_type;
+    /* Set transport */
+    alloc->transport = transport;
+    pj_turn_transport_add_ref(transport, alloc);
+
+    alloc->hkey.tp_type = transport->listener->tp_type;
     pj_memcpy(&alloc->hkey.clt_addr, src_addr, src_addr_len);
 
@@ -333,5 +340,6 @@
 
     /* Print info */
-    pj_ansi_strcpy(alloc->info, pj_turn_tp_type_name(listener->tp_type));
+    pj_ansi_strcpy(alloc->info, 
+		   pj_turn_tp_type_name(transport->listener->tp_type));
     alloc->info[3] = ':';
     pj_sockaddr_print(src_addr, alloc->info+4, sizeof(alloc->info)-4, 3);
@@ -371,5 +379,5 @@
 
     /* Respond to ALLOCATE request */
-    status = send_allocate_response(alloc, srv_sess, rdata);
+    status = send_allocate_response(alloc, srv_sess, transport, rdata);
     if (status != PJ_SUCCESS)
 	goto on_error;
@@ -389,5 +397,5 @@
     pj_strerror(status, str_tmp, sizeof(str_tmp));
     pj_stun_session_respond(srv_sess, rdata, PJ_STUN_SC_BAD_REQUEST, str_tmp, 
-			    PJ_TRUE, src_addr, src_addr_len);
+			    transport, PJ_TRUE, src_addr, src_addr_len);
 
     /* Cleanup */
@@ -401,5 +409,5 @@
 {
     if (relay->timer.id) {
-	pj_timer_heap_cancel(relay->allocation->listener->server->core.timer_heap, 
+	pj_timer_heap_cancel(relay->allocation->server->core.timer_heap, 
 			     &relay->timer);
 	relay->timer.id = PJ_FALSE;
@@ -428,5 +436,5 @@
 
     /* Unregister this allocation */
-    pj_turn_srv_unregister_allocation(alloc->listener->server, alloc);
+    pj_turn_srv_unregister_allocation(alloc->server, alloc);
 
     /* Destroy relay */
@@ -436,4 +444,10 @@
     if (alloc->lock) {
 	pj_lock_acquire(alloc->lock);
+    }
+
+    /* Unreference transport */
+    if (alloc->transport) {
+	pj_turn_transport_dec_ref(alloc->transport, alloc);
+	alloc->transport = NULL;
     }
 
@@ -466,4 +480,18 @@
 
 
+/*
+ * Handle transport closure.
+ */
+PJ_DEF(void) pj_turn_allocation_on_transport_closed( pj_turn_allocation *alloc,
+						     pj_turn_transport *tp)
+{
+    PJ_LOG(5,(alloc->obj_name, "Transport %s unexpectedly closed, destroying "
+	      "allocation %s", tp->info, alloc->info));
+    pj_turn_transport_dec_ref(tp, alloc);
+    alloc->transport = NULL;
+    destroy_allocation(alloc);
+}
+
+
 /* Initiate shutdown sequence for this allocation and start destroy timer.
  * Once allocation is marked as shutting down, any packets will be 
@@ -477,5 +505,5 @@
     if (alloc->relay.timer.id == TIMER_ID_TIMEOUT) {
 	/* Cancel existing shutdown timer */
-	pj_timer_heap_cancel(alloc->listener->server->core.timer_heap,
+	pj_timer_heap_cancel(alloc->server->core.timer_heap,
 			     &alloc->relay.timer);
 	alloc->relay.timer.id = TIMER_ID_NONE;
@@ -499,5 +527,5 @@
     /* Schedule destroy timer */
     alloc->relay.timer.id = TIMER_ID_DESTROY;
-    pj_timer_heap_schedule(alloc->listener->server->core.timer_heap,
+    pj_timer_heap_schedule(alloc->server->core.timer_heap,
 			   &alloc->relay.timer, &destroy_delay);
 }
@@ -515,5 +543,5 @@
     pj_assert(alloc->relay.timer.id != TIMER_ID_DESTROY);
     if (alloc->relay.timer.id != 0) {
-	pj_timer_heap_cancel(alloc->listener->server->core.timer_heap,
+	pj_timer_heap_cancel(alloc->server->core.timer_heap, 
 			     &alloc->relay.timer);
 	alloc->relay.timer.id = TIMER_ID_NONE;
@@ -524,5 +552,5 @@
 
     alloc->relay.timer.id = TIMER_ID_TIMEOUT;
-    status = pj_timer_heap_schedule(alloc->listener->server->core.timer_heap,
+    status = pj_timer_heap_schedule(alloc->server->core.timer_heap, 
 				    &alloc->relay.timer, &delay);
     if (status != PJ_SUCCESS) {
@@ -590,5 +618,5 @@
     
     /* TODO: get the requested address family from somewhere */
-    af = alloc->listener->addr.addr.sa_family;
+    af = alloc->transport->listener->addr.addr.sa_family;
 
     /* Save realm */
@@ -687,5 +715,6 @@
     }
     if (!pj_sockaddr_has_addr(&relay->hkey.addr)) {
-	pj_sockaddr_copy_addr(&relay->hkey.addr, &alloc->listener->addr);
+	pj_sockaddr_copy_addr(&relay->hkey.addr, 
+			      &alloc->transport->listener->addr);
     }
     if (!pj_sockaddr_has_addr(&relay->hkey.addr)) {
@@ -725,6 +754,6 @@
     pj_status_t status;
 
-    status = pj_stun_session_respond(alloc->sess, rdata, code, errmsg, cache,
-				     &alloc->hkey.clt_addr,
+    status = pj_stun_session_respond(alloc->sess, rdata, code, errmsg, NULL, 
+				     cache, &alloc->hkey.clt_addr,
 				     pj_sockaddr_get_len(&alloc->hkey.clt_addr.addr));
     if (status != PJ_SUCCESS) {
@@ -770,6 +799,6 @@
     }
 
-    status = pj_stun_session_send_msg(alloc->sess, PJ_TRUE, 
-				      &alloc->hkey.clt_addr,  
+    status = pj_stun_session_send_msg(alloc->sess, NULL, PJ_TRUE, 
+				      PJ_FALSE, &alloc->hkey.clt_addr,  
 				      pj_sockaddr_get_len(&alloc->hkey.clt_addr), 
 				      tdata);
@@ -791,11 +820,4 @@
     pj_memcpy(&perm->hkey.peer_addr, peer_addr, addr_len);
     
-    if (alloc->listener->tp_type == PJ_TURN_TP_UDP) {
-	perm->sock = alloc->listener->sock;
-    } else {
-	pj_assert(!"TCP is not supported yet");
-	return NULL;
-    }
-
     perm->allocation = alloc;
     perm->channel = PJ_TURN_INVALID_CHANNEL;
@@ -901,11 +923,26 @@
 	 */
 	unsigned options = PJ_STUN_CHECK_PACKET;
-	if (pkt->listener->tp_type == PJ_TURN_TP_UDP)
+	unsigned parsed_len = 0;
+
+	if (pkt->transport->listener->tp_type == PJ_TURN_TP_UDP)
 	    options |= PJ_STUN_IS_DATAGRAM;
 
 	status = pj_stun_session_on_rx_pkt(alloc->sess, pkt->pkt, pkt->len,
-					   options, NULL,
+					   options, NULL, &parsed_len,
 					   &pkt->src.clt_addr, 
 					   pkt->src_addr_len);
+
+	if (pkt->transport->listener->tp_type == PJ_TURN_TP_UDP) {
+	    pkt->len = 0;
+	} else if (parsed_len > 0) {
+	    if (parsed_len == pkt->len) {
+		pkt->len = 0;
+	    } else {
+		pj_memmove(pkt->pkt, pkt->pkt+parsed_len,
+			   pkt->len - parsed_len);
+		pkt->len -= parsed_len;
+	    }
+	}
+
 	if (status != PJ_SUCCESS) {
 	    alloc_err(alloc, "Error handling STUN packet", status);
@@ -924,5 +961,5 @@
 
 	/* For UDP check the packet length */
-	if (alloc->listener->tp_type == PJ_TURN_TP_UDP) {
+	if (alloc->transport->listener->tp_type == PJ_TURN_TP_UDP) {
 	    if (pkt->len < pj_ntohs(cd->length)+sizeof(*cd)) {
 		PJ_LOG(4,(alloc->obj_name, 
@@ -1004,8 +1041,8 @@
 
 	/* Send to client */
-	pj_turn_listener_sendto(alloc->listener, rel->tp.tx_pkt,
-			       len+sizeof(pj_turn_channel_data), 0,
-			       &alloc->hkey.clt_addr,
-			       pj_sockaddr_get_len(&alloc->hkey.clt_addr));
+	alloc->transport->sendto(alloc->transport, rel->tp.tx_pkt,
+			         len+sizeof(pj_turn_channel_data), 0,
+			         &alloc->hkey.clt_addr,
+			         pj_sockaddr_get_len(&alloc->hkey.clt_addr));
     } else {
 	/* Send Data Indication */
@@ -1027,6 +1064,6 @@
 				    (const pj_uint8_t*)pkt, len);
 
-	pj_stun_session_send_msg(alloc->sess, PJ_FALSE, 
-				 &alloc->hkey.clt_addr, 
+	pj_stun_session_send_msg(alloc->sess, NULL, PJ_FALSE, 
+				 PJ_FALSE, &alloc->hkey.clt_addr, 
 				 pj_sockaddr_get_len(&alloc->hkey.clt_addr), 
 				 tdata);
@@ -1077,4 +1114,5 @@
  */
 static pj_status_t stun_on_send_msg(pj_stun_session *sess,
+				    void *token,
 				    const void *pkt,
 				    pj_size_t pkt_size,
@@ -1084,8 +1122,10 @@
     pj_turn_allocation *alloc;
 
+    PJ_UNUSED_ARG(token);
+
     alloc = (pj_turn_allocation*) pj_stun_session_get_user_data(sess);
 
-    return pj_turn_listener_sendto(alloc->listener, pkt, pkt_size, 0,
-				  dst_addr, addr_len);
+    return alloc->transport->sendto(alloc->transport, pkt, pkt_size, 0,
+				    dst_addr, addr_len);
 }
 
@@ -1099,4 +1139,5 @@
 				      unsigned pkt_len,
 				      const pj_stun_rx_data *rdata,
+				      void *token,
 				      const pj_sockaddr_t *src_addr,
 				      unsigned src_addr_len)
@@ -1107,4 +1148,5 @@
     PJ_UNUSED_ARG(pkt);
     PJ_UNUSED_ARG(pkt_len);
+    PJ_UNUSED_ARG(token);
     PJ_UNUSED_ARG(src_addr);
     PJ_UNUSED_ARG(src_addr_len);
@@ -1275,4 +1317,5 @@
 					 unsigned pkt_len,
 					 const pj_stun_msg *msg,
+					 void *token,
 					 const pj_sockaddr_t *src_addr,
 					 unsigned src_addr_len)
@@ -1282,7 +1325,9 @@
     pj_turn_allocation *alloc;
     pj_turn_permission *perm;
+    pj_ssize_t len;
 
     PJ_UNUSED_ARG(pkt);
     PJ_UNUSED_ARG(pkt_len);
+    PJ_UNUSED_ARG(token);
     PJ_UNUSED_ARG(src_addr);
     PJ_UNUSED_ARG(src_addr_len);
@@ -1321,13 +1366,9 @@
 	return PJ_SUCCESS;
 
-    /* Relay the data to client */
-    if (alloc->hkey.tp_type == PJ_TURN_TP_UDP) {
-	pj_ssize_t len = data_attr->length;
-	pj_sock_sendto(alloc->listener->sock, data_attr->data, 
-		       &len, 0, &peer_attr->sockaddr,
-		       pj_sockaddr_get_len(&peer_attr->sockaddr));
-    } else {
-	pj_assert(!"TCP is not supported");
-    }
+    /* Relay the data to peer */
+    len = data_attr->length;
+    pj_sock_sendto(alloc->relay.tp.sock, data_attr->data, 
+		   &len, 0, &peer_attr->sockaddr,
+		   pj_sockaddr_get_len(&peer_attr->sockaddr));
 
     return PJ_SUCCESS;
